import JSONdb from 'simple-json-db';
import { ClientData } from "../../../types";
import { StorageInterface } from "./StorageInterface";

const db = new JSONdb('./data.json');

/**
 * Implementace úložiště používající JSON soubor.
 */
export default class JsonStorage implements StorageInterface {

    hasData(date: string): Promise<boolean> {
        return Promise.resolve(db.has(date));
    }

    getData(date: string): Promise<ClientData> {
        return db.get(date);
    }

    setData(date: string, data: ClientData): Promise<void> {
        db.set(date, data);
        return Promise.resolve();
    }
}